<?php
include("config.php");

//INCLUDE PARTNERS
include($SEOZAVR."/seozavr.php"); 
if (!defined('_SAPE_USER')){
    define('_SAPE_USER', $SAPE); 
}
require_once($PATH.'/'._SAPE_USER.'/sape.php'); 
$sape_context = new SAPE_context();
if (!defined('_SAPE_USER')){
define('_SAPE_USER', $SAPE);
}
require_once($PATH.'/'._SAPE_USER.'/sape.php'); 
$sape = new SAPE_client();
$cache_dir = '/'.$XAPDIR.'/';
include_once($PATH . $cache_dir . 'tnx.php');
$tnx = new TNX_n($XAPLOGIN, $cache_dir);

//FUNCTIONS
function inarray($arr,$value){
	for ($i=0;$i<count($arr);$i++){
		if(trim($value)==trim($arr[$i])) return true;
	}
	return false;
}

function Synonim($text){
	GLOBAL $SYNINCLUDEORIGINAL;
	$txt=$text;
	$handle = fopen("./synonim.txt", "r");
	$contents = ''; $i=0;
	while (!feof($handle)) {
		$buffer = fgets($handle, 4096);
		$marr=explode("=",$buffer);
		$original=$marr[0];
		$synarr=explode(",",$marr[1]);
		if($SYNINCLUDEORIGINAL)$synarr[]=$original;
		$syn=$synarr[rand()%count($synarr)];
		$txt=str_replace($original,$syn,$txt);
	  	$i++;
	}
	fclose($handle);
	$result.=$txt;
	return $result;
}

function ImageInsert($text){
	$txt=$text;
	$txt=ereg_replace("(\#l\#)+([^<>[:space:]]+[[:alnum:]/])+(\#\#)",
                     "<img src=\"./img/\\2\" align=\"left\" vspace=\"10\" hspace=\"10\">",$txt);
	$txt=ereg_replace("(\#r\#)+([^<>[:space:]]+[[:alnum:]/])+(\#\#)",
                     "<img src=\"./img/\\2\" align=\"right\" vspace=\"10\" hspace=\"10\">",$txt);
	$txt=ereg_replace("(\#c\#)+([^<>[:space:]]+[[:alnum:]/])+(\#\#)",
                     "<center><img src=\"./img/\\2\" vspace=\"10\" hspace=\"10\"></center>",$txt);
	return $txt;
}

function Oblako(){
	$d = dir("./data");
	while (false !== ($entry = $d->read())) {
	    if($entry=="."||$entry=="..") $a=1;
		else{
			$handle = fopen("./data/".$entry, "r");
			$contents = ''; $i=0;
			while (!feof($handle)) {
				$buffer = fgets($handle, 4096);
			  	if($i==1) $tag[]=$buffer;
			  $i++;
			}
			fclose($handle);
		}
	}
	$d->close(); $tags=Array();
	for($i=0;$i<count($tag);$i++){
		$tags=array_merge($tags,explode(",",$tag[$i]));
	}
	$result=Array();
	for($i=0;$i<count($tags);$i++){
		if(!inarray($result,$tags[$i])){
			$result[]=$tags[$i];
		}
	}
	return $result;
}

function Listing($tagging){
	GLOBAL $TITLE, $DESCR, $SH_LISTING;
	$TITLE=$tagging." - ".$TITLE;
	$d = dir("./data");
	while (false !== ($entry = $d->read())) {
	    if($entry=="."||$entry=="..") $a=1;
		else{
			$file[]=substr($entry,0,-4);
			$handle = fopen("./data/".$entry, "r");
			$contents = ''; $i=0;
			while (!feof($handle)) {
				$buffer = fgets($handle, 4096);
			  	if($i==0) $name[]=$buffer;
			  	elseif($i==1) $tag[]=$buffer;
			  	elseif($i==2) $anons[]=$buffer;
			  $i++;
			}
			fclose($handle);
		}
	}
	$d->close(); $tags=Array();
	$result="";
	for($i=0;$i<count($tag);$i++){
		if(inarray(explode(",",$tag[$i]),$tagging)){
			$txt=$SH_LISTING;
			$txt=str_replace("#file#",$file[$i],$txt);
			$txt=str_replace("#name#",$name[$i],$txt);
			$txt=str_replace("#anons#",$anons[$i],$txt);
			$result.=$txt;
		}
	}
	return $result;
}

function ListingSimple($tagging){
	GLOBAL $TITLE, $DESCR, $SH_LISTINGMENU;
	$TITLE=$tagging." - ".$TITLE;
	$d = dir("./data");
	while (false !== ($entry = $d->read())) {
	    if($entry=="."||$entry=="..") $a=1;
		else{
			$file[]=substr($entry,0,-4);
			$handle = fopen("./data/".$entry, "r");
			$contents = ''; $i=0;
			while (!feof($handle)) {
				$buffer = fgets($handle, 4096);
			  	if($i==0) $name[]=$buffer;
			  	elseif($i==1) $tag[]=$buffer;
			  	elseif($i==2) $anons[]=$buffer;
			  $i++;
			}
			fclose($handle);
		}
	}
	$d->close(); $tags=Array();
	$result="";
	for($i=0;$i<count($tag);$i++){
		if(inarray(explode(",",$tag[$i]),$tagging)){
			$txt=$SH_LISTINGMENU;
			$txt=str_replace("#file#",$file[$i],$txt);
			$txt=str_replace("#name#",$name[$i],$txt);
			$result.=$txt;
		}
	}
	return $result;
}

function Article($file){
	GLOBAL $TITLE, $DESCR, $sape_context, $SH_ARTICLE, $SH_TAGINARTICLE, $SYNONIMIZER;
	$handle = fopen("./data/".$file.".txt", "r");
	$contents = ''; $i=0;
	while (!feof($handle)) {
		$buffer = fgets($handle, 4096);
	  	if($i==0) $name=$buffer;
	  	elseif($i==1) $tag=$buffer;
	  	elseif($i==2) $anons=$buffer;
		else $content.=$SYNONIMIZER?Synonim($buffer):$buffer;
	  	$i++;
	}
	fclose($handle);
	$TITLE=$name." - ".$TITLE;
	$DESCR=$anons;
	$result="";
	$txt=$SH_ARTICLE;
	$txt=str_replace("#name#",$name,$txt);
	$content=ImageInsert($content);
	$txt=str_replace("#content#",$sape_context->replace_in_text_segment($content),$txt);

	$tagarr=explode(",",$tag); $tagi="";
	for($i=0;$i<count($tagarr);$i++){
		$tags=trim($tagarr[$i]);
		$txt0=$SH_TAGINARTICLE;
		$txt0=str_replace("#tags#",$tags,$txt0);
		$tagi.=$txt0;
	}
	$txt=str_replace("#tags#",$tagi,$txt);
	$result.=$txt;
	return $result;
}

function Main(){
	GLOBAL $SH_MAIN;
	$handle = fopen("./main.txt", "r");
	$contents = ''; $i=0;
	while (!feof($handle)) {
		$buffer = fgets($handle, 4096);
		$content.=$SYNONIMIZER?Synonim($buffer):$buffer;
	  	$i++;
	}
	fclose($handle);
	$txt=$SH_MAIN;
	$content=ImageInsert($content);
	$txt=str_replace("#content#",$content,$txt);
	$result.=$txt;
	return $result;
}

function RandArticle(){
	GLOBAL $SH_RANDOM;
	$d = dir("./data");
	while (false !== ($entry = $d->read())) {
	    if($entry=="."||$entry=="..") $a=1;
		else{
			$art[]=$entry;
		}
	}
	$numart=rand()%count($art);
	$file=substr($art[$numart],0,-4);
	$handle = fopen("./data/".$art[$numart]."", "r");
	$i=0;
	while (!feof($handle)) {
		$buffer = fgets($handle, 4096);
	  	if($i==0) $name=$buffer;
	  	elseif($i==1) $tag=$buffer;
	  	elseif($i==2) $anons=$buffer;
	  	$i++;
	}
	fclose($handle);
	$result="";
	$txt=$SH_RANDOM;
	$txt=str_replace("#name#",$name,$txt);
	$txt=str_replace("#anons#",$anons,$txt);
	$txt=str_replace("#file#",$file,$txt);
	$result.=$txt;
	return $result;
}
?>